#include <stdlib.h>
#include <string.h>

#include "colorscaletrue24.h"
#include "util.h"

ColorScaleTrueColor24::ColorScaleTrueColor24(int s, Visual* v) : ColorScale(s)
{
  // this makes the assumption of one byte per color.

  colors_ = new unsigned char[s*3];
  int rs = decodeMask((unsigned long)v->red_mask);
  int gs = decodeMask((unsigned long)v->green_mask);
  int bs = decodeMask((unsigned long)v->blue_mask);
      
  for (int i=0; i<s; i++) {
    unsigned long r = psColors_[i*3+2];
    unsigned long g = psColors_[i*3+1];
    unsigned long b = psColors_[i*3];
    unsigned long result = 0;
    result |= r << rs;
    result |= g << gs;
    result |= b << bs;

    memcpy(colors_+i*3, &result, 3);
  }
}

LinearScaleTrueColor24::LinearScaleTrueColor24(int s, 
					       unsigned short* indexCells,
					       unsigned char* colorCells,
					       int count, Visual* v) 
  : LinearScale(s, indexCells, colorCells, count), ColorScaleTrueColor24(s, v),
    ColorScale(s)
{}

LogScaleTrueColor24::LogScaleTrueColor24(int s,
					 unsigned short* indexCells,
					 unsigned char* colorCells,
					 int count, Visual* v)
  : LogScale(s, indexCells, colorCells, count), ColorScaleTrueColor24(s, v),
    ColorScale(s) {}

SquaredScaleTrueColor24::SquaredScaleTrueColor24(int s,
						 unsigned short* indexCells,
						 unsigned char* colorCells,
						 int count, Visual* v)
  : SquaredScale(s, indexCells, colorCells, count), ColorScaleTrueColor24(s,v),
    ColorScale(s) {}

SqrtScaleTrueColor24::SqrtScaleTrueColor24(int s,
					   unsigned short* indexCells,
					   unsigned char* colorCells,
					   int count, Visual* v)
  : SqrtScale(s, indexCells, colorCells, count), ColorScaleTrueColor24(s, v),
    ColorScale(s) {}
