#include <stdlib.h>
#include <string.h>

#include "colorscaletrue32.h"
#include "util.h"

ColorScaleTrueColor32::ColorScaleTrueColor32(int s, Visual* v) : ColorScale(s)
{
  // this makes the assumption of one byte per color.

  colors_ = new unsigned char[s*4];
  int rs = decodeMask((unsigned long)v->red_mask);
  int gs = decodeMask((unsigned long)v->green_mask);
  int bs = decodeMask((unsigned long)v->blue_mask);
      
  for (int i=0; i<s; i++) {
    unsigned long r = psColors_[i*3+2];
    unsigned long g = psColors_[i*3+1];
    unsigned long b = psColors_[i*3];
    unsigned long result = 0;
    result |= r << rs;
    result |= g << gs;
    result |= b << bs;

    memcpy(colors_+i*4, &result, 4);
  }
}

LinearScaleTrueColor32::LinearScaleTrueColor32(int s, 
					       unsigned short* indexCells,
					       unsigned char* colorCells,
					       int count, Visual* v) 
  : LinearScale(s, indexCells, colorCells, count), ColorScaleTrueColor32(s, v),
    ColorScale(s)
{}

LogScaleTrueColor32::LogScaleTrueColor32(int s,
					 unsigned short* indexCells,
					 unsigned char* colorCells,
					 int count, Visual* v)
  : LogScale(s, indexCells, colorCells, count), ColorScaleTrueColor32(s, v),
    ColorScale(s) {}

SquaredScaleTrueColor32::SquaredScaleTrueColor32(int s,
						 unsigned short* indexCells,
						 unsigned char* colorCells,
						 int count, Visual* v)
  : SquaredScale(s, indexCells, colorCells, count), ColorScaleTrueColor32(s,v),
    ColorScale(s) {}

SqrtScaleTrueColor32::SqrtScaleTrueColor32(int s,
					   unsigned short* indexCells,
					   unsigned char* colorCells,
					   int count, Visual* v)
  : SqrtScale(s, indexCells, colorCells, count), ColorScaleTrueColor32(s, v),
    ColorScale(s) {}
