#include <math.h>
#include <iostream.h>

#include "contourscale.h"

ContourScale::ContourScale(int s)
{
  size_ = s;
  level_ = new float[size_];

  for (int i=0; i<size_; i++)
    level_[i] = 0;
}

ContourScale::~ContourScale()
{
  if (level_)
    delete [] level_;
}

void ContourScale::list()
{
  for (int i=0; i<size_; i++)
    cerr << i << ' ' << level_[i] << endl;
}

LinearContourScale::LinearContourScale(int s, float low, float high) : ContourScale(s)
{
  float diff = high-low;
  for (int i=0; i<size_; i++)
    level_[i] = (1-((float)i/(size_-1)))*diff + low;
}

LogContourScale::LogContourScale(int s, float low, float high) : ContourScale(s)
{
  float diff = high-low;
  for (int i=0; i<size_; i++)
    level_[i] = (1-(log10(i+1)/log10(size_)))*diff+low;
}

SquaredContourScale::SquaredContourScale(int s, float low, float high)
  : ContourScale(s)
{
  float diff = high-low;
  for (int i=0; i<size_; i++) {
    float a = (float)i/(size_-1);
    level_[i] = (1-(a*a))*diff + low;
  }
}

SqrtContourScale::SqrtContourScale(int s, float low, float high) : ContourScale(s)
{
  float diff = high-low;
  for (int i=0; i<size_; i++)
    level_[i] = (1-sqrt((float)i/(size_-1)))*diff+low;
}

