#include <iostream.h>

#include "grid.h"
#include "util.h"
#include "fitsimage.h"

Grid::Grid(Frame* p, Frame::CoordSystem s, Frame::CoordFormat f, 
	   const char* c) : parent(p), system(s), format_(f)
{
  colorName = dupstr(c);
  color_ = parent->getColor(colorName);
  width = 0;
  height = 0;
}

Grid::~Grid()
{
  if (colorName)
    delete colorName;
}

void Grid::invalid()
{
}

void Grid::color(const char* c)
{
  if (colorName)
    delete colorName;

  colorName = dupstr(c);
  color_ = parent->getColor(colorName);
}

void Grid::format(Frame::CoordFormat f)
{
  format_ = f;
}

void Grid::render()
{
}

void Grid::ps(Frame::PSColorSpace mode)
{
}

/*
void Grid::render()
{
  extern int pgcrvl_(int* axen, char** idents, char** opt, int* labctl,
		     int* labden, int* ci, int* gcode, double* tiklen,
		     int* ng1, double* grid1, int* ng2, double* grid2,
		     long* doeq,
		     
		     int (*nlfunc)(int*, int*, int*, int*, char*, int*, 
				   double*, double*, double*, int*,
				   double*, int*, short),

		     int* nlc, int* nli, 
		     int* nld, char* nlcprm, int* nliprm, double* nldprm, 
		     int* nc, int* ic, double* cache, int* ierr, 
		     short idents_len, short opt_len, short nlcprm_len);

  extern int pgwcsl_(int* opcode, int* nlc, int* nli, 
		     int* nld, char* ctype, int* wcs, double* nldprm, 
		     double* world, double* pixel, int* contrl,
		     double* contxt, int* ierr, short ctype_len);

  int axen[2] = {512,512};
  char* idents[3] = {"X Axis","Y Axis","Title"};
  char* opt[2] = {"A","B"};
  int labctl = 0;
  int labden = 1224;
  int ci[7] = {-1,-1,-1,-1,-1,-1,-1};
  int gcode[2] = {2,2};
  double tiklen = 0;
  int ng1 = 2;
  double grid1[2] = {-180,180};
  int ng2 = 2;
  double grid2[2] = {-90,90};
  long doeq = 1;

  int nlc = 16;
  int nli = 4;
  int nld = 50;
  char nlcprm[16];
  int nliprm[4];
  double nldprm[50];
  int nc = 256;
  int ic = -1;
  double cache[4*257];
  int ierr;
  short idents_len;
  short opt_len;
  short nlcprm_len;

  pgcrvl_(axen, idents, opt, &labctl, &labden, ci, gcode, &tiklen, 
	  &ng1, grid1, &ng2, grid2, &doeq, pgwcsl_, &nlc, &nli, &nld,
	  nlcprm, nliprm, nldprm, &nc, &ic, cache, &ierr, 
	  idents_len, opt_len, nlcprm_len);
}
*/
