#ifndef __grid_h__
#define __grid_h__

#include "frame.h"

class Grid {
 private:
  Frame* parent;
  char* colorName;
  int color_;
  Frame::CoordSystem system;
  Frame::CoordFormat format_;
  int width;
  int height;

 public:
  Grid(Frame*, Frame::CoordSystem, Frame::CoordFormat, const char*);
  virtual ~Grid();

  void invalid();
  void render();
  void ps(Frame::PSColorSpace);
  void color(const char*);
  void format(Frame::CoordFormat f);
  const char* getColor() {return colorName;}
  Frame::CoordSystem getSystem() {return system;}
  Frame::CoordFormat getFormat() {return format_;}
};

#endif
