#ifndef __rectangle_h__
#define __rectangle_h__

#include "annuli.h"

class Rectangle : public AnnuliMarker {
private:
  Vector size;
  double angle;

  void calcPoints(double);
  void updateHandles();

public:
  Rectangle(Frame* p, const Vector& ctr, const Vector& s, double a,
	    const char* clr,  const char* f, const char* t, unsigned short prop);

  void updateCoords(Matrix&);
  void editBegin(int);
  void edit(const Vector&, int);
  void editEnd();
  void rotate(const Vector&, int);
  int isIn(const Vector&);

  const Vector& getSize() {return size;}
  double getAngle() {return angle;}
  void setSize(const Vector&);
  void setAngle(double);

  void list(ostream&, int, int);
  void listSAOtng(ostream&, int, int);
  void listSAOimage(ostream&);
  void listPros(ostream&, int, int);
};

#endif
