#ifndef __util_h__
#define __util_h__

#include <iostream.h>

extern const double D_PI;
extern int hmsSign;

extern char* dupstr(const char*);
extern char* toLower(const char*);
extern char* toUpper(const char*);

extern double degToRad(double);
extern double radToDeg(double);
extern double hmsToDegree(int, double, double, double);
extern double dmsToDegree(int, double, double, double);
extern double parseHMS(const char*);
extern double parseDMS(const char*);

extern unsigned char decodeMask(unsigned char, int*);
extern unsigned short decodeMask(unsigned short, int*);
extern int decodeMask(unsigned long);

extern double RGB2Gray(double, double, double);
extern unsigned char RGB2Gray(unsigned char, unsigned char, unsigned char);
extern void RGB2CMYK(unsigned char, unsigned char, unsigned char,
		     unsigned char*, unsigned char*, unsigned char*, 
		     unsigned char*);
extern ostream& psColorGray(const char*, ostream&);
extern ostream& psColorRGB(const char*, ostream&);
extern ostream& psColorCMYK(const char*, ostream&);

#endif
